----------------------------------------------------------------------------------
-- Author:          Taimour Wehbe, taimour.wehbe@gatech.edu
-- 
-- Create Date:     16:04:02 08/24/2018 
-- Design Name:     result_comp
-- Module Name:     result_comp
-- Target Devices:  Digilent Zedboard Development Board
-- Tool versions:   Vivado v2017.2.1
-- Description: 
--
--      This is a comparator file that compares generated hash values to a database of hashes and declares an alarm if the generated
--      value is not present in the database. The alarm signal in this file is the ouput signal "comp_result".
--      
--      
------------------------------ COPYRIGHT NOTICE -----------------------------------------------------------------------
--                                                                   
--      This file is part of the code assigned in Lab 2 of ECE 4823/8873 Advanced Hardware-Oriented Security and Trust
--      at the Georgia Institute of Technology
--                                                                   
--      Author(s):      Taimour Wehbe, taimour.wehbe@gatech.edu
--                      Hardware/Software Codesign for Security Group
--      
--      Copyright (C) 2018 Georgia Institute of Technology
--      ---------------------------------------------------
--      
-----------------------------------------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity result_comp is
    -- KEEP THE SAME PORT DECLARATIONS FOR THIS MODULE AS IS
    port (
        -- hash value
        H0_i : in std_logic_vector (31 downto 0);
        H1_i : in std_logic_vector (31 downto 0);
        H2_i : in std_logic_vector (31 downto 0);
        H3_i : in std_logic_vector (31 downto 0);
        H4_i : in std_logic_vector (31 downto 0);
        H5_i : in std_logic_vector (31 downto 0);
        H6_i : in std_logic_vector (31 downto 0);
        H7_i : in std_logic_vector (31 downto 0);
        -- output signal indicating whether the generated hash value matched any hash in the database
        comp_result : out std_logic
    );                      
end result_comp;

architecture behavioral of result_comp is
    -- CREATE ANY NEEDED SIGNALS FOR YOUR DESIGN HERE
begin
    --=============================================================================================
    -- Behavioral logic
    --=============================================================================================
    
    -- IN THIS SECTION, YOU NEED TO IMPLEMENT THE NEEDED LOGIC TO COMPARE THE GENERATED HASH VALUE
    -- (COMING AS AN INPUT INTO THIS MODULE) TO THE FOLLOWING SET OF LEGITIMATE HASHES
    --     VALID HASH 1: x"BA7816BF 8F01CFEA 414140DE 5DAE2223 B00361A3 96177A9C B410FF61 F20015AD"
    --     VALID HASH 2: x"68325720 aabd7c82 f30f554b 313d0570 c95accbb 7dc4b5aa e11204c0 8ffe732b"
    --     VALID HASH 3: x"7abc22c0 ae5af26c e93dbb94 433a0e0b 2e119d01 4f8e7f65 bd56c61c cccd9504"
    
    -- IF THE GENERATED HASH MATCHES ANY OF THE ABOVE VALUES, THE comp_result OUTPUT SIGNAL SHOULD
    -- BE ASSERTED, OTHERWISE A BINARY VALUE OF '0' SHOULD BE OUTPUT
    
    
end behavioral;

